import { DevSupport } from "@react-buddy/ide-toolbox";
import { AdminContext, AdminUI, Resource } from "react-admin";
import { authProvider } from "../authProvider";
import { dataProvider } from "../dataProvider/graphqlDataProvider";
import { ComponentPreviews, useInitial } from "../dev";
import { i18nProvider } from "../i18nProvider";
import { AdminLayout } from "./AdminLayout";

export const App = () => {
  return (
    <AdminContext
      dataProvider={dataProvider}
      authProvider={authProvider}
      i18nProvider={i18nProvider}
    >
      <DevSupport ComponentPreviews={ComponentPreviews} useInitialHook={useInitial}>
        <AdminUI layout={AdminLayout}>
        </AdminUI>
      </DevSupport>
    </AdminContext>
  );
};
