import { AmplicodeComponentOptions } from "../../../building-blocks/stages/options/pieces/amplicode";
import { ScreenAnswers } from "../../../building-blocks/stages/answers/amplicode/ScreenAnswers";
import { AmplicodeTemplateModelStage } from "../../../building-blocks/pipelines/amplicodePipeline";
import { BaseTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel";
import { UtilTemplateModel } from "../../../building-blocks/stages/template-model/pieces/util";
import { ScreenTemplateModel } from "../../../building-blocks/stages/template-model/pieces/amplicode/ScreenTemplateModel";
import { FiltersTemplateModel, OrderByTemplateModel, PaginationTemplateModel } from "../../react-typescript/entity-list/template-model";
import { GqlAttributeModel } from "../../../building-blocks/stages/template-model/pieces/entity";
export interface AdvancedListAnswers extends ScreenAnswers {
    listQuery: string;
    deleteMutation?: string;
}
export interface EntityListTemplateModel extends BaseTemplateModel, UtilTemplateModel, ScreenTemplateModel, FiltersTemplateModel, OrderByTemplateModel, PaginationTemplateModel {
    queryName: string;
    queryString: string;
    deleteMutationName?: string;
    deleteMutationString?: string;
    attributes: GqlAttributeModel[];
    allAttributes: string[];
    itemComponentName?: string;
    refetchQuery: string;
    entityName: string;
}
export declare const deriveEntityListTemplateModel: AmplicodeTemplateModelStage<AmplicodeComponentOptions, AdvancedListAnswers, EntityListTemplateModel>;
