"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveEntityListTemplateModel = void 0;
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const getTopFieldName_1 = require("../../../building-blocks/stages/template-model/pieces/graphql-utils/getTopFieldName");
const getOperationDefinitionName_1 = require("../../../building-blocks/stages/template-model/pieces/graphql-utils/getOperationDefinitionName");
const getEntityAttributes_1 = require("../../../building-blocks/stages/template-model/pieces/graphql-utils/getEntityAttributes");
const getEntityName_1 = require("../../../building-blocks/stages/template-model/pieces/graphql-utils/getEntityName");
const getAttributeNames_1 = require("../../../building-blocks/stages/template-model/pieces/graphql-utils/getAttributeNames");
const BaseTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel");
const util_1 = require("../../../building-blocks/stages/template-model/pieces/util");
const ScreenTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/ScreenTemplateModel");
const template_model_1 = require("../../react-typescript/entity-list/template-model");
const deriveEntityListTemplateModel = async (options, answers, schema) => {
    if (schema == null) {
        throw new Error('Schema not found');
    }
    const { componentName, listQuery: queryString, deleteMutation: deleteMutationString, } = answers;
    const queryNode = graphql_tag_1.default(queryString);
    const mutationNode = deleteMutationString != null ? graphql_tag_1.default(deleteMutationString) : undefined;
    const queryName = getTopFieldName_1.getTopFieldName(queryNode);
    const refetchQuery = getOperationDefinitionName_1.getOperationDefinitionName(queryNode);
    const deleteMutationName = mutationNode != null ? getTopFieldName_1.getTopFieldName(mutationNode) : undefined;
    const attributes = getEntityAttributes_1.getEntityAttributes(queryNode, schema, 'id');
    const entityName = getEntityName_1.getEntityName(queryName, schema);
    const allAttributes = getAttributeNames_1.getAttributeNames(entityName, schema);
    return {
        ...BaseTemplateModel_1.baseTemplateModel,
        ...util_1.templateUtilities,
        ...ScreenTemplateModel_1.deriveScreenTemplateModel(options, answers, schema),
        ...template_model_1.deriveFiltersTemplateModel(queryName, undefined, schema),
        ...template_model_1.deriveOrderByTemplateModel(queryName, undefined, schema),
        ...template_model_1.derivePatinationTemplateModel(queryName, undefined, schema),
        componentName,
        queryName,
        queryString,
        deleteMutationName,
        deleteMutationString,
        attributes,
        allAttributes,
        refetchQuery,
        entityName
    };
};
exports.deriveEntityListTemplateModel = deriveEntityListTemplateModel;
//# sourceMappingURL=template-model.js.map